package mesClasses;

public class BufferCirculaire<X> {
	private Cellule<X> ecriture;
	private Cellule<X> lecture;
	private int taille;
	private int nbElements;

	public BufferCirculaire(int taille)
	{
		Cellule<X> precedant = new Cellule<X>();
		this.ecriture = precedant;
		this.lecture = precedant;

		Cellule<X> courant;
		for (int i=1; i < taille; i++)
		{
			courant = new Cellule<X>();
			precedant.setSuivant(courant);
			precedant = courant;
		}
		precedant.setSuivant(this.ecriture);
		this.taille = taille;
	}

	public boolean estPlein()
	{
		return this.taille == this.nbElements;
	}

	public boolean estVide()
	{
		return 0 == this.nbElements;
	}

	public void ecrire(X val)
	{
		if (!estPlein())
		{
			this.ecriture.setValeur(val);
			this.ecriture = this.ecriture.getSuivant();
			this.nbElements++;
		}
	}

	public X lire()
	{
		X res = null;
		if (!estVide())
		{
			res = this.lecture.getValeur();
			this.lecture=this.lecture.getSuivant();
			this.nbElements--; 
		}
		return res;
	}

	@Override
	public String toString() {
		// TODO Auto-generated method stub
		Cellule<X> deb = this.lecture;
		Cellule<X> cour = this.lecture;
		String s="";
		do
		{
			s= s + cour.getValeur();
			if (cour == lecture)
			{
				s=s+"L";
			}
			if (cour == ecriture)
			{
				s=s+"E";
			}
			s =s +"->";
			cour=cour.getSuivant();
		}while (cour != deb);
		
		return s;
	}

}
