package mesClasses;

public class FileAttente<X> {
	private Cellule<X> debut;
	private int taille;
	private int nbElements;

	public FileAttente(int taille)
	{
		this.debut = new Cellule<X>();
		this.taille = taille;
	}

	public boolean estPlein()
	{
		return this.taille == this.nbElements;
	}

	public boolean estVide()
	{
		return 0 == this.nbElements;
	}

	public void ecrire(X val)
	{
		if (!estPlein())
		{
			Cellule<X> c = new Cellule<X>();
			c.setValeur(val);
			c.setSuivant(this.debut.getSuivant());
			this.debut.setSuivant(c);
			this.nbElements++;
		}
	}

	public X lire()
	{
		X res = null;
		if (!estVide())
		{
			Cellule<X> curseur = this.debut.getSuivant();
			while (curseur.getSuivant() != null)
				curseur = curseur.getSuivant();
			res = curseur.getValeur();
			
			this.nbElements--;
			curseur = this.debut;
			while (curseur.getSuivant().getSuivant() != null)
				curseur = curseur.getSuivant();
			curseur.setSuivant(null);
			
		}
		return res;
	}
	@Override
	public String toString() {
		// TODO Auto-generated method stub

		String s="";
		if (!estVide())
		{
			Cellule<X> curseur = this.debut.getSuivant();
			while (curseur!=null)
			{
				s = s + curseur.getValeur()+ "->";
				curseur = curseur.getSuivant();
			}
		}
		return s;
	}

}
