package mesClasses;

public class ListD<E> {
	private CelluleD<E> tete;

	public ListD() {
		this.tete = new CelluleD<E>();
	}

	public boolean estVide()
	{
		return this.tete.getSuivant() == null;
	}

	public void insereQueue(E val)
	{
		CelluleD<E> curseur = this.tete;
		while (curseur.getSuivant()!=null)
			curseur=curseur.getSuivant();
		CelluleD<E> c = new CelluleD<E>();
		c.setValeur(val);
		c.setSuivant(null);
		c.setPrecedent(curseur);
		curseur.setSuivant(c);
	}
	
	public void insereTete(E val)
	{
		CelluleD<E> c = new CelluleD<E>();
		c.setValeur(val);
		c.setSuivant(tete.getSuivant());
		c.setPrecedent(tete);

		if (c.getSuivant()!=null)
			tete.getSuivant().setPrecedent(c);
		tete.setSuivant(c);
	}

	public void supprimeQueue()
	{
		if (! estVide())
		{
			CelluleD<E> curseur = this.tete;
			while (curseur.getSuivant().getSuivant()!=null)
				curseur=curseur.getSuivant();
			curseur.setSuivant(null);
		}
	}
	
	public void supprimeTete()
	{
		if (!estVide())
		{
			tete = tete.getSuivant();
			tete.setPrecedent(null);
		}
	}

	public E getTete()
	{
		E res = null;
		if (!estVide())
		{
			res = tete.getSuivant().getValeur();
		}
		return res;
	}
	
	public E getQueue()
	{
		E res = null;
		if (!estVide())
		{
		CelluleD<E> curseur = this.tete;
		
		while (curseur.getSuivant()!=null)
			curseur = curseur.getSuivant();
			res = curseur.getValeur();
		}
		return res;
	}
	
	
	@Override
	public String toString() {
		String res1= "[X]->";
		CelluleD<E> curseur = this.tete;
		while (curseur.getSuivant()!=null)
		{
			curseur = curseur.getSuivant();
			res1 = res1 + "["+curseur.getValeur()+"]->";

		}
		String res2="";
		while (curseur.getPrecedent()!=null)
		{
			res2="<-["+curseur.getValeur()+"]"+res2;
			curseur = curseur.getPrecedent();
		}
		res2="[X]"+res2;
		return res1+"\n"+res2;
	}


}
